;
;   BLANK SCREEN APPLICATION
;
;   Compile with FASM for Menuet
;
   
use32
   
  org    0x0
  db     'MENUET01'
  dd     0x01
  dd     START
  dd     I_END
  dd     0x100000
  dd     0x7fff0
  dd     0x0 , 0x0
   
START:
   
  mov  eax,14
  int  0x40
   
  mov  word [maxy],ax
  shr  eax,16
  mov  word [maxx],ax
   
;B+ Load parameters
  mov  ebx,ss_file
  mov  ecx,0
  mov  edx,-1
  mov  esi,screen_saver_par
  mov  eax,6
  int  0x40
;E:.
   
;B+ Wait to switch blank
wait_new:
  mov  ecx,[wait_blank]
not_user_event:
  mov  ebx,25
  mov  eax,5
  int  0x40
   
  sub  ecx,1
  jz   start_blank
  mov  eax,52
  int  0x40
  or   eax,eax
  jz   not_user_event
  jmp  wait_new
start_blank:
;E:.
   
still_:
  call draw_window
still:
;B+ Enents
   
  mov  eax,10
  int  0x40
   
  cmp  eax,1
  je   still_
  cmp  eax,2
  je   key
  cmp  eax,3
  je   button
   
  jmp  still
   
key:
  mov  eax,-1
  int  0x40
   
button:
  mov  eax,17
  int  0x40
   
  cmp  ah,1
  jne  still
finish:
;B+ Restart screen saver
  mov  ebx,ss_prog
  mov  ecx,0
  mov  eax,19
  int  0x40
   
  mov  ebx,50
  mov  eax,5
  int  0x40
   
  mov  eax,-1
  int  0x40
;E:.
   
;E:.
draw_window:
;B+ Draw
   
  mov  eax,12
  mov  ebx,1
  int  0x40
   
  mov  ebx,[maxx]
  mov  ecx,[maxy]
  mov  edx,0x0
  mov  esi,0x0
  mov  edi,0x0
  mov  eax,0
  int  0x40
   
  jmp  [next]
   
next_draw:
  mov  ebx,[maxx]
  sub  ebx,30
  shl  ebx,16
  mov  bx,30
  mov  ecx,30
  mov  edx,1
  mov  esi,0x0
  mov  eax,8
  int  0x40
   
  mov  ebx,2
  mov  eax,12
  int  0x40
   
  ret
   
start_text:
  mov  [next],next_draw
   
  mov  eax,14
  int  0x40
   
  mov  ebx,eax
  shr  ebx,1
  and  ebx,0xffff7fff
  sub  ebx,6*(text_end-text)/2*65536+3
  mov  ecx,0xffffff
  mov  edx,text
  mov  esi,text_end-text
  mov  eax,4
  int  0x40
   
 push ebx
  call wait_
  call wait_
   
  mov  ebx,[esp]
  mov  ecx,0x70cfff
  mov  eax,4
  int  0x40
   
  call wait_
  call wait_
  call wait_
   
  mov  ebx,[esp]
  mov  ecx,0x30a0ff
  mov  eax,4
  int  0x40
   
  call wait_
   
 pop  ebx
  mov  ecx,0x0
  mov  eax,4
  int  0x40
   
  jmp  next_draw
   
wait_:
  mov  ecx,7
wait__:
  mov  ebx,25
  mov  eax,5
  int  0x40
   
  mov  eax,11
  int  0x40
  cmp  eax,2
  je   finish
   
  dec  ecx
  or   ecx,ecx
  jnz  wait__
  ret
   
;E:.
;B+ Data
maxx dd 640
maxy dd 480
   
next dd start_text
   
text db 'TO RESTORE:  CLICK TOP/LEFT UNVISIBLE BUTTON  OR  PRESS ANY KEY '
text_end:
   
ss_prog db 'BLANK      '
ss_file db 'BLANKTIMSPE'
screen_saver_par:
wait_blank dd  5*60*4 ;  5 min.
wait_off   dd 10*60*4 ; 10 min.
   
;E:.
   
I_END:
   
   