;
;   GERSCHI MENUET EXPLANATION
;
;   Compile with FASM 1.30+
;
   
use32
   
               org    0x0
   
               db     'MENUET01'              ; 8 byte id
               dd     0x01                    ; header version
               dd     START                   ; start of code
               dd     I_END                   ; size of image
               dd     0x100000                ; memory for app
               dd     0x7fff0                 ; esp
               dd     0x0 , 0x0               ; I_Param , I_Icon
   
START:                          ; start of execution
   
     call draw_window
   
still:
   
    mov  eax,10                 ; wait here for event
    int  0x40
   
    cmp  eax,1                  ; redraw request ?
    je   red
    cmp  eax,2                  ; key in buffer ?
    je   key
    cmp  eax,3                  ; button in buffer ?
    je   button
   
    jmp  still
   
  red:                          ; redraw
    call draw_window
    jmp  still
   
  key:                          ; key
    mov  eax,2                  ; just read it and ignore
    int  0x40
    jmp  still
   
  button:                       ; button
    mov  eax,17                 ; get id
    int  0x40
   
    cmp  ah,1                   ; button id=1 ?
    jne  noclose
   
    mov  eax,-1                 ; close this program
    int  0x40
  noclose:
   
    jmp  still
   
   
   
   
;   *********************************************
;   *******  WINDOW DEFINITIONS AND DRAW ********
;   *********************************************
   
   
draw_window:
   
   
    mov  eax,12                    ; function 12:tell os about windowdraw
    mov  ebx,1                     ; 1, start of draw
    int  0x40
   
   
    mov  eax,0
    mov  ebx,40*65536+300
    mov  ecx,40*65536+275          ; [y start] *65536 + [y size]
    mov  edx,0x82111199            ; color of work area RRGGBB,8->color gl
    mov  esi,0x805080d0            ; color of grab bar  RRGGBB,8->color gl
    mov  edi,0x005080d0            ; color of frames    RRGGBB
    int  0x40
   
                                   ; WINDOW LABEL
    mov  eax,4                     ; function 4 : write text to window
    mov  ebx,8*65536+8             ; [x start] *65536 + [y start]
    mov  ecx,0x10ffffff            ; font 1 & color ( 0xF0RRGGBB )
    mov  edx,labelt                ; pointer to text beginning
    mov  esi,labellen-labelt       ; text length
    int  0x40
   
                                   ; CLOSE BUTTON
    mov  eax,8                     ; function 8 : define and draw button
    mov  ebx,(300-19)*65536+12     ; [x start] *65536 + [x size]
    mov  ecx,5*65536+12            ; [y start] *65536 + [y size]
    mov  edx,1                     ; button id
    mov  esi,0x6688dd              ; button color RRGGBB
    int  0x40
   
   
    mov  ebx,20*65536+35           ; draw info text with function 4
     mov  ecx,0xffffff
     mov  edx,text
    mov  esi,43
  newline:
    mov  eax,4
    int  0x40
    add  ebx,16
    add  edx,43
    cmp  [edx],byte 'x'
    jne  newline
   
    mov  eax,12                    ; function 12:tell os about windowdraw
    mov  ebx,2                     ; 2, end of draw
    int  0x40
   
    ret
   
   
; DATA AREA
   
   
text:
    db 'GERSCHI MENUET VERSION 0.4                 '
    db 'This is just a small distribution of MENUET'
    db 'Kernel Version is 0.74 pre 3.0             '
    db '                                           '
    db 'I added a few new apps and some other new  '
    db 'features like: New icons on the desktop and'
    db 'a backgroundpic (load from BGROUND)        '
    db '                                           '
    db 'Open the systree to see something real     '
    db 'exciting... Now you can delete files (F8)  '
    db 'and View them with F3                      '
    db '                                           '
    db '       VISIT MENUET.2GO4.DE FOR MORE...    '
    db '                     THANKS FOR SUPPORT!   '
    db '                          STEFAN 13.06.2003'
    db 'x                                          '
   
   
labelt:
     db   'GERSCHI MENUET 0.4'
labellen:
   
I_END:
   
   
   
   