;
;    EXAMPLE APPLICATION
;
;    Compile with FASM for Menuet
;
   
use32
   
                org     0x0
   
                db      'MENUET00'              ; 8 byte id
                dd      38                      ; required os
                dd      START                   ; program start
                dd      I_END                   ; program image size
                dd      0x100000                ; required amount of memory
                                                ; esp = 0x7FFF0
                dd      0x00000000              ; reserved=no extended header
   
   
   
START:                          ; start of execution
   
    call open_file
   
    call draw_window            ; at first, draw the window
   
still:
   
    mov  eax,10                 ; wait here for event
    int  0x40
   
    cmp  eax,1                  ; redraw request ?
    je   red
    cmp  eax,2                  ; key in buffer ?
    je   key
    cmp  eax,3                  ; button in buffer ?
    je   button
   
    jmp  still
   
  red:                          ; redraw
    call draw_window
    jmp  still
   
  key:                          ; key
    mov  eax,2                  ; just read it and ignore
    int  0x40
    jmp  still
   
  button:                       ; button
    mov  eax,17                 ; get id
    int  0x40
   
    cmp  ah,1                   ; button id=1 ?
    jne  noclose
    mov  eax,-1                 ; close this program
    int  0x40
  noclose:
   
    jmp  still
   
   
;   *********************************************
;   *******  WINDOW DEFINITIONS AND DRAW ********
;   *********************************************
   
   
draw_window:
   
    mov  eax,12                    ; function 12:tell os about windowdraw
    mov  ebx,1                     ; 1, start of draw
    int  0x40
   
                                   ; DRAW WINDOW
    mov  eax,0                     ; function 0 : define and draw window
    mov  ebx,100*65536+400         ; [x start] *65536 + [x size]
    mov  ecx,100*65536+270         ; [y start] *65536 + [y size]
    mov  edx,0x03224466            ; color of work area RRGGBB,8->c
    mov  esi,0x006688aa            ; color of grab bar  RRGGBB,8->color gl
    mov  edi,0x00ffffff            ; color of frames    RRGGBB
    int  0x40
   
                                   ; WINDOW LABEL
    mov  eax,4                     ; function 4 : write text to window
    mov  ebx,8*65536+8             ; [x start] *65536 + [y start]
    mov  ecx,0x00ffffff            ; color of text RRGGBB
    mov  edx,labelt                ; pointer to text beginning
    mov  esi,labellen-labelt       ; text length
    int  0x40
   
    mov  eax,8
    mov  ebx,280*65536+16*6
    mov  ecx,240*65536+14
    mov  edx,2
    mov  esi,0x5599cc
    int  0x40
   
    mov  ebx,15*65536+125
    add  edx,1
    mov  eax,8
    int  0x40
   
    add  ebx,127*65536
    add  edx,1
    mov  eax,8
    int  0x40
   
   
    mov  eax,4
    mov  ebx,15*65536+243
    mov  ecx,0xffffff
    mov  edx,buttons
    mov  esi,blen-buttons
    int  0x40
   
   
    mov  ebx,280*65536+35           ; draw info text with function 4
    mov  ecx,0xffffff
    mov  edx,text
    mov  esi,16
    mov  edi,16
  newline:
   
    pusha                          ; hext
   
    mov  edi,16
    mov  ecx,edx
    mov  edx,ebx
    sub  edx,265*65536
   
   newhex:
   
    mov  eax,47
    mov  ebx,0x00020101
    mov  esi,0xffff00
    int  0x40
   
    add  edx,16*65536
    add  ecx,1
    dec  edi
    jne  newhex
   
    popa
   
    mov  eax,4                     ; text
    int  0x40
    add  ebx,12
    add  edx,16
    dec  edi
    jnz  newline
   
    mov  eax,12                    ; function 12:tell os about windowdraw
    mov  ebx,2                     ; 2, end of draw
    int  0x40
   
    ret
   
   
   
file_name  db  'EXAMPLE       '
   
open_file:
   
    pusha
   
    mov  eax,6
    mov  ebx,file_name
    mov  ecx,0
    mov  edx,-1
    mov  esi,text
    int  0x40
   
    popa
   
    ret
   
   
   
; DATA AREA
   
labelt:  db  'HEXVIEW'
labellen:
   
buttons  db  '        UP                   DOWN'
         db  '              EXAMPLE      '
blen:
   
text:
   
I_END:
   
   
   
   