;
;   LAUNCHER
;
;   Compile with FASM for Menuet
;
   
use32
   
               org    0x0
   
               db     'MENUET01'              ; 8 byte id
               dd     0x01                    ; header version
               dd     START                   ; start of code
               dd     I_END                   ; size of image
               dd     0x100000                ; memory for app
               dd     0x7fff0                 ; esp
               dd     0x0 , 0x0               ; I_Param , I_Icon
   
START:                          ; start of execution
   
    call draw_window
   
    mov  eax,5
    mov  ebx,25
    int  0x40
   
still:
   
    mov  eax,11                 ; wait here for event
    int  0x40
   
    cmp  eax,1                  ; redraw request ?
    je   red
    cmp  eax,2                  ; key in buffer ?
    je   key
    cmp  eax,3                  ; button in buffer ?
    je   button
   
    call launch_applications
   
    jmp  still
   
  red:                          ; redraw
    call draw_window
    jmp  still
   
  key:                          ; key
    mov  eax,2                  ; just read it and ignore
    int  0x40
    jmp  still
   
  button:                       ; button
    mov  eax,17                 ; get id
    int  0x40
   
    cmp  ah,1                   ; button id=1 ?
    jne  noclose
   
    mov  eax,-1                 ; close this program
    int  0x40
  noclose:
   
    jmp  still
   
   
applications  dd  file_list
   
files         dd  4
   
   
file_list:
   
    db   'PIC4            '
    db   'BOOT            '
    dd   100
   
    db   'ICONMNGR        '
    db   'BOOT            '
    dd   100
   
    db   'PANEL           '
    db   'BOOT            '
    dd   100

    db   'G               '
    db   'BOOT            '
    dd   100
   
star db  '*'
   
pos dd   35*65536+45
   
   
launch_applications:
   
    pusha
   
    mov  eax,4
    mov  ebx,[pos]
    mov  ecx,0x000000
    mov  edx,star
    mov  esi,1
    int  0x40
   
    add  [pos],10
   
    mov  eax,19
    mov  ebx,[applications]
    mov  ecx,ebx
    add  ecx,16
    int  0x40
   
    mov  eax,5
    mov  ebx,[ecx+16]
    int  0x40
   
    dec  [files]
    jne  more
    mov  eax,-1
    int  0x40
  more:
   
    add  [applications],32+4
   
    popa
   
    ret
   
   
   
   
;   *********************************************
;   *******  WINDOW DEFINITIONS AND DRAW ********
;   *********************************************
   
   
draw_window:
   
   
    mov  eax,12                    ; function 12:tell os about windowdraw
    mov  ebx,1                     ; 1, start of draw
    int  0x40
   
    mov  eax,14
    int  0x40
   
    mov  ecx,eax
    and  ecx,0xffff
    shr  ecx,1
    sub  ecx,100
    shl  ecx,16
   
    shr  eax,17
    sub  eax,150
    shl  eax,16
    mov  ebx,eax
   
                                   ; DRAW WINDOW
    mov  eax,0                     ; function 0 : define and draw window
    mov  bx,300                    ; [x start] *65536 + [x size]
    mov  cx,100                    ; [y start] *65536 + [y size]
    mov  edx,0x03ffffff            ; color of work area RRGGBB,8->color gl
    mov  esi,0x805080d0            ; color of grab bar  RRGGBB,8->color gl
    mov  edi,0x005080d0            ; color of frames    RRGGBB
    int  0x40
   
                                   ; WINDOW LABEL
    mov  eax,4                     ; function 4 : write text to window
    mov  ebx,8*65536+8             ; [x start] *65536 + [y start]
    mov  ecx,0x00ddeeff            ; color of text RRGGBB
    mov  edx,labelt                ; pointer to text beginning
    mov  esi,labellen-labelt       ; text length
    int  0x40
   
                                   ; APPLICATION // PARAMETER
    mov  eax,4                     ; function 4 : write text to window
    mov  ebx,45*65536+30           ; [x start] *65536 + [y start]
    mov  ecx,0x000000              ; color of text RRGGBB
    mov  edx,text                  ; pointer to text beginning
    mov  esi,textlen-text          ; text length
    int  0x40
   
   
    mov  ebx,45*65536+45           ; draw info text with function 4
    mov  ecx,0x224466
    mov  edx,file_list
    mov  esi,32
    mov  edi,[files]
  newline:
    mov  eax,4
    int  0x40
    add  ebx,10
    add  edx,32+4
    dec  edi
    jnz  newline
   
    mov  eax,12                    ; function 12:tell os about windowdraw
    mov  ebx,2                     ; 2, end of draw
    int  0x40
   
    ret
   
   
; DATA AREA
   
   
labelt:
      db   'LAUNCHER'
labellen:
   
text:
     db   'APPLICATION     PARAMETER'
textlen:
I_END:
   
   
   