;
;    STDIN / STDOUT TEST for Menuet
;
;    Binary runs in Linux and LEMU - Linux emulator for Menuet.
;
;    This is the ELF-header that Menuet 0.59 understands and works
;    in Linux also. Do not change the header bits. Compile with fasm.
;
   
   
use32
   
              org    0x80000
   
              db     0x7F, 'ELF'           ; e_ident
              db     1, 1, 1
    times 9   db     0
              dw     2                     ; e_type
              dw     3                     ; e_machine
              dd     1                     ; e_version
              dd     START                 ; e_entry
              dd     phdr - 0x80000        ; e_phoff
              dd     0                     ; e_shoff
              dd     0                     ; e_flags
              dw     0x34                  ; e_ehsize
              dw     0x20                  ; e_phentsize
              dw     1                     ; e_phnum
              dw     0                     ; e_shentsize
              dw     0                     ; e_shnum
              dw     0                     ; e_shstrndx
phdr:
              dw     1                     ; p_type
              dw     0
              dw     0                     ; p_offset
              dw     0
              dd     0x80000               ; p_vaddr
              dd     0x80000               ; p_paddr
              dd     elf_filesz-0x80000    ; p_filesz
              dd     elf_memsz-0x80000     ; p_memsz
              dd     7                     ; elf_phdr_flags
              dd     0x1000                ; p_align
   
; end of header
   
START:
   
         mov     eax,4                   ; say hello to user
         mov     ebx,1
         mov     ecx,msgtext1
         mov     edx,len1-msgtext1
         int     0x80
   
         mov     eax,3                   ; read input
         mov     ebx,0
         mov     edx,1024
         mov     ecx,input
         int     0x80
   
         push    eax
         push    ecx
   
         mov     eax,4                   ; output
         mov     ebx,1
         mov     ecx,msgtext2
         mov     edx,len2-msgtext2
         int     0x80
   
         pop     ecx
         pop     edx
   
         mov     eax,4                    ; write user input
         mov     ebx,1
         int     0x80
   
         mov     eax,4
         mov     ebx,1
         mov     ecx,msgtext3
         mov     edx,4
         int     0x80
   
         mov     eax,1                   ; end application
         mov     ebx,0
         int     0x80
   
   
msgtext1     db  10,'Greetings '
             db  10,'This elf binary runs under both Linux and Menuet'
             db  10,'Binary: stdio  Source: stdio.asm'
             db  10,'Please type something',10
len1:
   
msgtext2     db  10,'You wrote : '
len2:
   
msgtext3     db  10,'EOF'
len3:
   
elf_filesz:
   
input        db  '                                                        '
   
elf_memsz:
   
   
   