; mos.inc 0.0.1
; Copyright (c) 2002 Thomas Mathys
; killer@vantage.ch
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


;**********************************************************
; generates a menuetos 01 header
; takes 2-6 parameters:
;
; MOS_HEADER01 start,end[,appmem,esp,i_param,i_icon]
;**********************************************************

%macro MOS_HEADER01 2-6 0x100000,0x7fff0,0,0
	org	0x0
	db	'MENUET01'		; 8 byte id
	dd	0x01			; header version
	dd	%1			; start of code
	dd	%2			; image size
	dd	%3			; application memory
	dd	%4			; esp
	dd	%5			; i_param
	dd	%6			; i_icon
%endmacro


;**********************************************************
; window color structure
;**********************************************************

MOS_WNDCOLORS_SIZE	equ	(10*4)
struc MOS_WNDCOLORS
	.frame:			resd	1
	.grab:			resd	1
	.grabButton:		resd	1
	.grabButtonText:	resd	1
	.grabText:		resd	1
	.work:			resd	1
	.workButton:		resd	1
	.workButtonText:	resd	1
	.workText:		resd	1
	.workGraphics:		resd	1
endstruc


;**********************************************************
; system call numbers
;**********************************************************

MOS_SC_EXIT		equ	-1
MOS_SC_DEFINEWINDOW	equ	0
MOS_SC_PUTPIXEL		equ	1
MOS_SC_GETKEY		equ	2
MOS_SC_GETSYSCLOCK	equ	3
MOS_SC_WRITETEXT	equ	4
MOS_SC_DELAY		equ	5
MOS_SC_REDRAWSTATUS	equ	12
MOS_SC_DRAWBAR		equ	13
MOS_SC_GETSCREENMAX	equ	14
MOS_SC_WAITEVENTTIMEOUT	equ	23
MOS_SC_GETDATE		equ	29
MOS_SC_GETSCREENPIXEL	equ	35
MOS_SC_DRAWLINE		equ	38
MOS_SC_WRITENUMBER	equ	47
MOS_SC_WINDOWPROPERTIES	equ	48


;**********************************************************
; event numbers
;**********************************************************

MOS_EVT_NONE		equ	0
MOS_EVT_REDRAW		equ	1
MOS_EVT_KEY		equ	2
MOS_EVT_BUTTON		equ	3
