
;
;    Ok, this is the sceleton that MENUET 0.38 understands.
;    Do not change the header bits for now. Compile with nasm 0.97+
;
;    EXAMPLE APPLICATION
;
;    system call: int 0x40
;

use32

        	org	0x0

		db	'MENUET00'              ; 8 byte id
                dd      38                      ; required os
		dd	START			; program start
                dd      I_END                   ; program image size
		dd	0x100000		; reguired amount of memory
		dd	0x00000000		; reserved=no extended header




START:                          ; start of execution


    call draw_window            ; at first, draw the window


still:

    mov  eax,10                 ; wait here for event
    int  0x40

    cmp  eax,1                  ; redraw request ?
    jz   red
    cmp  eax,2                  ; key in buffer ?
    jz   key
    cmp  eax,3                  ; button in buffer ?
    jz   button

    jmp  still                  

  red:                          ; redraw
    call draw_window

    jmp  still

  key:                          ; key
    mov  eax,2                  ; just read it and ignore
    int  0x40

    jmp  still

  button:                       ; button
    mov  eax,17
    int  0x40

    cmp  ah,1                   ; button id=1 ?
    jnz  noclose
    mov  eax,0xffffffff         ; close this program
    int  0x40
  noclose:

    cmp  ah,2
    jnz  notest2
    mov  [0x100000],byte 1
  notest2:

    cmp  ah,3
    jnz  notest3
    mov  [0x0fffff],byte 1
  notest3:

    cmp  ah,4
    jnz  notest4
    jmp  dword 0x100000
  notest4:


    jmp  still


;   *********************************************
;   *******  WINDOW DEFINITIONS AND DRAW ********
;   *********************************************


draw_window:

    mov  eax,12                    ; function 12:tell os about windowdraw
    mov  ebx,1                     ; 1, start of draw
    int  0x40

                                   ; DRAW WINDOW
    mov  eax,0                     ; function 0 : define and draw window
    mov  ebx,100*65536+300         ; [x start] *65536 + [x size]
    mov  ecx,100*65536+120         ; [y start] *65536 + [y size]
    mov  edx,0x001111cc            ; color of work area RRGGBB
    mov  esi,0x8099bbff            ; color of grab bar  RRGGBB,8->color glide
    mov  edi,0x0099bbee            ; color of frames    RRGGBB
    int  0x40

                                   ; WINDOW LABEL
    mov  eax,4                     ; function 4 : write text to window
    mov  ebx,8*65536+8             ; [x start] *65536 + [y start]
    mov  ecx,0x00ffffff            ; color of text RRGGBB
    mov  edx,tlabel                 ; pointer to text beginning
    mov  esi,labellen-tlabel        ; text length
    int  0x40

                                   ; CLOSE BUTTON
    mov  eax,8                     ; function 8 : define and draw button
    mov  ebx,(300-19)*65536+12     ; [x start] *65536 + [x size]
    mov  ecx,5*65536+12            ; [y start] *65536 + [y size]
    mov  edx,1                     ; button id
    mov  esi,0x22aacc              ; button color RRGGBB
    int  0x40


    mov  eax,8                     ; function 8 : define and draw button
    mov  ebx,20*65536+12           ; [x start] *65536 + [x size]
    mov  ecx,35*65536+12           ; [y start] *65536 + [y size]
    mov  edx,2                     ; button id
    mov  esi,0x22aacc              ; button color RRGGBB
    int  0x40

    mov  eax,8                     ; function 8 : define and draw button
    mov  ebx,20*65536+12           ; [x start] *65536 + [x size]
    mov  ecx,55*65536+12           ; [y start] *65536 + [y size]
    mov  edx,3                     ; button id
    mov  esi,0x22aacc              ; button color RRGGBB
    int  0x40

    mov  eax,8                     ; function 8 : define and draw button
    mov  ebx,20*65536+12           ; [x start] *65536 + [x size]
    mov  ecx,75*65536+12           ; [y start] *65536 + [y size]
    mov  edx,4                     ; button id
    mov  esi,0x22aacc              ; button color RRGGBB
    int  0x40



    cld
    mov  ebx,25*65536+36           ; draw info text with function 4
    mov  ecx,0xffffff
    mov  edx,text
    mov  esi,40
  newline:
    mov  eax,4                     
    int  0x40
    add  ebx,10
    add  edx,40
    cmp  [edx],byte 'x'
    jnz  newline


    mov  eax,12                    ; function 12:tell os about windowdraw
    mov  ebx,2                     ; 2, end of draw
    int  0x40

    ret


; DATA AREA
 

text:
    db '     MOV [0x100000],BYTE 1              '
    db '                                        '
    db '     MOV [0x0FFFFF],BYTE 1              '
    db '                                        '
    db '     JMP DWORD 0x100000                 '
    db '                                        '
    db 'x                                       '



tlabel:
    db   'MENUET MEMORY PROTECTION TEST'
labellen:

I_END:



